--
-- self
-- for all self
--
-- @author gswlad
-- @date  28/07/11
--
-- Copyright (C) 

superwse = {};



function superwse.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function superwse:load(xmlFile)



self.drucklight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drucklight#index"));
	self.druck2light = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drucklight#index2"));
	self.druck3light = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drucklight#index3"));



local rotationPartNodeDruck = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartDruck#index"));
    if rotationPartNodeDruck ~= nil then
        self.rotationPartDruck = {};
        self.rotationPartDruck.node = rotationPartNodeDruck;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDruck#minRot"));
        self.rotationPartDruck.minRot = {};
        self.rotationPartDruck.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDruck.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDruck.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDruck#maxRot"));
        self.rotationPartDruck.maxRot = {};
        self.rotationPartDruck.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDruck.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDruck.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartDruck.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDruck#rotTime"), 2)*1000;
        self.rotationPartDruck.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDruck#touchRotLimit"), 10));
    end;
	
	local rotationPartNodeDruckLight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartDruckLight#index"));
    if rotationPartNodeDruckLight ~= nil then
        self.rotationPartDruckLight = {};
        self.rotationPartDruckLight.node = rotationPartNodeDruckLight;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDruckLight#minRot"));
        self.rotationPartDruckLight.minRot = {};
        self.rotationPartDruckLight.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDruckLight.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDruckLight.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDruckLight#maxRot"));
        self.rotationPartDruckLight.maxRot = {};
        self.rotationPartDruckLight.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDruckLight.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDruckLight.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartDruckLight.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDruckLight#rotTime"), 2)*1000;
        self.rotationPartDruckLight.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDruckLight#touchRotLimit"), 10));
    end;


    self.handbrakelight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.handbrakelight#index"));
    self.brakelight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.brakelight#index"));
	self.reverselight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.reverselight#index"));
	
	
	self.controlpath = Utils.getFilename("textur/JDHud.png", self.baseDirectory);
    self.hudjohndeereWidth = 0.200;
    self.hudjohndeereHeight = 0.300;
	self.hudjohndeerePoxX = 0.815;
    self.hudjohndeerePoxY = 1-1.05;
    self.hudjohndeereOverlay = Overlay:new("hudjohndeereControl", self.controlpath, self.hudjohndeerePoxX, self.hudjohndeerePoxY, self.hudjohndeereWidth, self.hudjohndeereHeight);
	self.isAutomatic = false;
	self.gang0 = true;
	self.handbrake = true;
	self.cos = 20000;
	self.druckLevel = 0;

	handbrakeSoundFile = Utils.getFilename("sounds/handbrake.wav", self.baseDirectory);
    self.handbrakeSoundId = createSample("handbrakeSound");
    loadSample(self.handbrakeSoundId, handbrakeSoundFile, false);
    self.handbrakePlaying = false;
	
	brakeSoundFile = Utils.getFilename("sounds/brake2.wav", self.baseDirectory);
    self.brakeSoundId = createSample("brakeSound");
    loadSample(self.brakeSoundId, brakeSoundFile, false);
    self.brakePlaying = false;
	
	brakereleaseSoundFile = Utils.getFilename("sounds/brake.wav", self.baseDirectory);
    self.brakereleaseSoundId = createSample("brakereleaseSound");
    loadSample(self.brakereleaseSoundId, brakereleaseSoundFile, false);
    self.brakereleasePlaying = false;
	
	fuelwarningSoundFile = Utils.getFilename("sounds/fuelwarning.wav", self.baseDirectory);
    self.fuelwarningSoundId = createSample("fuelwarningSound");
    loadSample(self.fuelwarningSoundId, fuelwarningSoundFile, false);
    self.fuelwarningPlaying = false;
	
	compressorSoundFile = Utils.getFilename("sounds/compressor.wav", self.baseDirectory);
    self.compressorSoundId = createSample("compressorSound");
    loadSample(self.compressorSoundId, compressorSoundFile, false);
    self.compressorPlaying = false;
	
	compressorstopSoundFile = Utils.getFilename("sounds/compressorstop.wav", self.baseDirectory);
    self.compressorstopSoundId = createSample("compressorstopSound");
    loadSample(self.compressorstopSoundId, compressorstopSoundFile, false);
    self.compressorstopPlaying = false;


 self.fender = {};
    self.fender[1] = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.fender.fender1#index"));
    self.fender[2] = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.fender.fender2#index"));



local rotationPartNodeWajcha = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartWajcha#index"));
    if rotationPartNodeWajcha ~= nil then
        self.rotationPartWajcha = {};
        self.rotationPartWajcha.node = rotationPartNodeWajcha;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartWajcha#minRot"));
        self.rotationPartWajcha.minRot = {};
        self.rotationPartWajcha.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartWajcha.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartWajcha.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartWajcha#maxRot"));
        self.rotationPartWajcha.maxRot = {};
        self.rotationPartWajcha.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartWajcha.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartWajcha.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartWajcha.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartWajcha#rotTime"), 2)*1000;
        self.rotationPartWajcha.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartWajcha#touchRotLimit"), 10));
    end;
	
	local rotationPartNodeWajcha2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartWajcha2#index"));
    if rotationPartNodeWajcha2 ~= nil then
        self.rotationPartWajcha2 = {};
        self.rotationPartWajcha2.node = rotationPartNodeWajcha2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartWajcha2#minRot"));
        self.rotationPartWajcha2.minRot = {};
        self.rotationPartWajcha2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartWajcha2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartWajcha2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartWajcha2#maxRot"));
        self.rotationPartWajcha2.maxRot = {};
        self.rotationPartWajcha2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartWajcha2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartWajcha2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartWajcha2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartWajcha2#rotTime"), 2)*1000;
        self.rotationPartWajcha2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartWajcha2#touchRotLimit"), 10));
    end;





local rotationPartNodeBrake = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartBrake#index"));
    if rotationPartNodeBrake ~= nil then
        self.rotationPartBrake = {};
        self.rotationPartBrake.node = rotationPartNodeBrake;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartBrake#minRot"));
        self.rotationPartBrake.minRot = {};
        self.rotationPartBrake.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartBrake.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartBrake.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartBrake#maxRot"));
        self.rotationPartBrake.maxRot = {};
        self.rotationPartBrake.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartBrake.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartBrake.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartBrake.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartBrake#rotTime"), 2)*1000;
        self.rotationPartBrake.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartBrake#touchRotLimit"), 10));
    end;


klaksonFile = Utils.getFilename("sounds/horn.wav", self.baseDirectory);
    self.klaksonId = createSample("klakson");
    loadSample(self.klaksonId, klaksonFile, false);
    self.klaksonPlaying = false;


self.tanklight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tanklight#index"));
	self.tank2light = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tanklight#index2"));
self.tanklightActive = false;




 self.radioCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.radio#count"),0);
	self.radioVolume = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.radio#volume"),0);
    self.radioOn = false;
    self.radio = {};
	self.currentSong = 1;
    for i=1, self.radioCount do
        local objname = string.format("vehicle.radio.song" .. "%d",i);
        self.radio[i] = {};
        local filename = Utils.getFilename(getXMLString(xmlFile, objname .. "#filename"),self.baseDirectory);
		self.radio[i].song = createSample(string.format("track" .. "%d",i));
		loadSample(self.radio[i].song, filename, false);
    end;
	self.songPlayed = false;


self.numBacklights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.backlights#count"), 0);
    self.backlights= {};
    for i=1, self.numBacklights do
        local backlightnamei = string.format("vehicle.backlights.backlight" .. "%d", i);
        self.backlights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, backlightnamei .. "#index"));
        setVisibility(self.backlights[i], false);
    end;	
	self.backlightsActive = false;	

self.farLight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.farLight#index"));
self.farLightActive = false;
	

    self.wiper1Active = false;	
	self.wiper2Active = false;	
    self.delayOnLeft = 0;
    self.delayOffLeft = 0;
    self.delayOnRight = 0;
    self.delayOffRight = 0;
    self.delayWischer1 = 0;
    self.delayWischer2 = 0;
    self.delayOn = 0;
    self.delayOff = 0;
    self.deltafo = 0;
	
    

	
    local wiper1Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wiper1#index"));
    if wiper1Node ~= nil then
        self.wiper1 = {};
        self.wiper1.node = wiper1Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wiper1#minRot"));
        self.wiper1.minRot = {};
        self.wiper1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.wiper1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.wiper1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wiper1#maxRot"));
        self.wiper1.maxRot = {};
        self.wiper1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.wiper1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.wiper1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.wiper1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wiper1#rotTime"), 2)*1000;
        self.wiper1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wiper1#touchRotLimit"), 10));
    end;
	
	local wiper2Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wiper2#index"));
    if wiper2Node ~= nil then
        self.wiper2 = {};
        self.wiper2.node = wiper2Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wiper2#minRot"));
        self.wiper2.minRot = {};
        self.wiper2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.wiper2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.wiper2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wiper2#maxRot"));
        self.wiper2.maxRot = {};
        self.wiper2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.wiper2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.wiper2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.wiper2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wiper2#rotTime"), 2)*1000;
        self.wiper2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wiper2#touchRotLimit"), 10));
    end;


 self.workLight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.workLight#index"));

 self.workLightActive = false;


  local translationHyd1Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationHyd1#index"));
    if translationHyd1Node ~= nil then
        self.translationHyd1 = {};
        self.translationHyd1.node = translationHyd1Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd1#minTrans"));
        self.translationHyd1.minTrans = {};
        self.translationHyd1.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd1.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd1.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd1#maxTrans"));
        self.translationHyd1.maxTrans = {};
        self.translationHyd1.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd1.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd1.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationHyd1.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd1#transTime"), 2)*1000;
        self.translationHyd1.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd1#touchTransLimit"), 10);
    end;

 local translationHyd2Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationHyd2#index"));
    if translationHyd2Node ~= nil then
        self.translationHyd2 = {};
        self.translationHyd2.node = translationHyd2Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd2#minTrans"));
        self.translationHyd2.minTrans = {};
        self.translationHyd2.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd2.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd2#maxTrans"));
        self.translationHyd2.maxTrans = {};
        self.translationHyd2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd2.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationHyd2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd2#transTime"), 2)*1000;
        self.translationHyd2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd2#touchTransLimit"), 10);
    end;





local translationHyd3Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationHyd3#index"));
    if translationHyd3Node ~= nil then
        self.translationHyd3 = {};
        self.translationHyd3.node = translationHyd3Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd3#minTrans"));
        self.translationHyd3.minTrans = {};
        self.translationHyd3.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd3.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd3.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd3#maxTrans"));
        self.translationHyd3.maxTrans = {};
        self.translationHyd3.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd3.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd3.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationHyd3.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd3#transTime"), 2)*1000;
        self.translationHyd3.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd3#touchTransLimit"), 10);
    end;
local translationHyd4Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationHyd4#index"));
    if translationHyd4Node ~= nil then
        self.translationHyd4 = {};
        self.translationHyd4.node = translationHyd4Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd4#minTrans"));
        self.translationHyd4.minTrans = {};
        self.translationHyd4.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd4.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd4.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd4#maxTrans"));
        self.translationHyd4.maxTrans = {};
        self.translationHyd4.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd4.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd4.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationHyd4.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd4#transTime"), 2)*1000;
        self.translationHyd4.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd4#touchTransLimit"), 10);
    end;
local translationHyd5Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationHyd5#index"));
    if translationHyd5Node ~= nil then
        self.translationHyd5 = {};
        self.translationHyd5.node = translationHyd5Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd5#minTrans"));
        self.translationHyd5.minTrans = {};
        self.translationHyd5.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd5.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd5.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd5#maxTrans"));
        self.translationHyd5.maxTrans = {};
        self.translationHyd5.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd5.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd5.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationHyd5.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd5#transTime"), 2)*1000;
        self.translationHyd5.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd5#touchTransLimit"), 10);
    end;
local translationHyd6Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationHyd6#index"));
    if translationHyd6Node ~= nil then
        self.translationHyd6 = {};
        self.translationHyd6.node = translationHyd6Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd6#minTrans"));
        self.translationHyd6.minTrans = {};
        self.translationHyd6.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd6.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd6.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd6#maxTrans"));
        self.translationHyd6.maxTrans = {};
        self.translationHyd6.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd6.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd6.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationHyd6.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd6#transTime"), 2)*1000;
        self.translationHyd6.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd6#touchTransLimit"), 10);
    end;
local translationHyd7Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationHyd7#index"));
    if translationHyd7Node ~= nil then
        self.translationHyd7 = {};
        self.translationHyd7.node = translationHyd7Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd7#minTrans"));
        self.translationHyd7.minTrans = {};
        self.translationHyd7.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd7.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd7.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd7#maxTrans"));
        self.translationHyd7.maxTrans = {};
        self.translationHyd7.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd7.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd7.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationHyd7.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd7#transTime"), 2)*1000;
        self.translationHyd7.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd7#touchTransLimit"), 10);
    end;
local translationHyd8Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationHyd8#index"));
    if translationHyd8Node ~= nil then
        self.translationHyd8 = {};
        self.translationHyd8.node = translationHyd8Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd8#minTrans"));
        self.translationHyd8.minTrans = {};
        self.translationHyd8.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd8.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd8.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd8#maxTrans"));
        self.translationHyd8.maxTrans = {};
        self.translationHyd8.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd8.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd8.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationHyd8.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd8#transTime"), 2)*1000;
        self.translationHyd8.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd8#touchTransLimit"), 10);
    end;
local translationHyd9Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationHyd9#index"));
    if translationHyd9Node ~= nil then
        self.translationHyd9 = {};
        self.translationHyd9.node = translationHyd9Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd9#minTrans"));
        self.translationHyd9.minTrans = {};
        self.translationHyd9.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd9.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd9.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd9#maxTrans"));
        self.translationHyd9.maxTrans = {};
        self.translationHyd9.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd9.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd9.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationHyd9.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd9#transTime"), 2)*1000;
        self.translationHyd9.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd9#touchTransLimit"), 10);
    end;
local translationHyd10Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationHyd10#index"));
    if translationHyd10Node ~= nil then
        self.translationHyd10 = {};
        self.translationHyd10.node = translationHyd10Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd10#minTrans"));
        self.translationHyd10.minTrans = {};
        self.translationHyd10.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd10.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd10.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationHyd10#maxTrans"));
        self.translationHyd10.maxTrans = {};
        self.translationHyd10.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationHyd10.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationHyd10.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationHyd10.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd10#transTime"), 2)*1000;
        self.translationHyd10.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationHyd10#touchTransLimit"), 10);
    end;








self.crankshaftNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.crankshaft#index"));
self.crankshaft1Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.crankshaft1#index"));
self.crankshaft2Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.crankshaft2#index"));
self.crankshaft3Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.crankshaft3#index"));
self.crankshaft4Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.crankshaft4#index"));
self.crankshaft5Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.crankshaft5#index"));
self.crankshaft6Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.crankshaft6#index"));
self.crankshaft7Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.crankshaft7#index"));
self.crankshaft8Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.crankshaft8#index"));
self.crankshaft9Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.crankshaft9#index"));
self.crankshaft10Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.crankshaft10#index"));
self.crankshaft11Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.crankshaft11#index"));
self.crankshaft12Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.crankshaft12#index"));




local rotationPartNodeKmh1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartKmh1#index"));
    if rotationPartNodeKmh1 ~= nil then
        self.rotationPartKmh1 = {};
        self.rotationPartKmh1.node = rotationPartNodeKmh1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartKmh1#minRot"));
        self.rotationPartKmh1.minRot = {};
        self.rotationPartKmh1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartKmh1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartKmh1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartKmh1#maxRot"));
        self.rotationPartKmh1.maxRot = {};
        self.rotationPartKmh1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartKmh1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartKmh1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartKmh1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartKmh1#rotTime"), 2)*1000;
        self.rotationPartKmh1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartKmh1#touchRotLimit"), 10));
    end;
	
	local rotationPartNodeKmh2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartKmh2#index"));
    if rotationPartNodeKmh2 ~= nil then
        self.rotationPartKmh2 = {};
        self.rotationPartKmh2.node = rotationPartNodeKmh2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartKmh2#minRot"));
        self.rotationPartKmh2.minRot = {};
        self.rotationPartKmh2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartKmh2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartKmh2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartKmh2#maxRot"));
        self.rotationPartKmh2.maxRot = {};
        self.rotationPartKmh2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartKmh2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartKmh2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartKmh2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartKmh2#rotTime"), 2)*1000;
        self.rotationPartKmh2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartKmh2#touchRotLimit"), 10));
    end;

local rotationPartNodeTanknadel = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartTanknadel#index"));
    if rotationPartNodeTanknadel ~= nil then
        self.rotationPartTanknadel = {};
        self.rotationPartTanknadel.node = rotationPartNodeTanknadel;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTanknadel#minRot"));
        self.rotationPartTanknadel.minRot = {};
        self.rotationPartTanknadel.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTanknadel.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTanknadel.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTanknadel#maxRot"));
        self.rotationPartTanknadel.maxRot = {};
        self.rotationPartTanknadel.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTanknadel.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTanknadel.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartTanknadel.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTanknadel#rotTime"), 2)*1000;
        self.rotationPartTanknadel.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTanknadel#touchRotLimit"), 10));
    end;
	
	local rotationPartNodeTanknadel2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartTanknadel2#index"));
    if rotationPartNodeTanknadel2 ~= nil then
        self.rotationPartTanknadel2 = {};
        self.rotationPartTanknadel2.node = rotationPartNodeTanknadel2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTanknadel2#minRot"));
        self.rotationPartTanknadel2.minRot = {};
        self.rotationPartTanknadel2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTanknadel2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTanknadel2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTanknadel2#maxRot"));
        self.rotationPartTanknadel2.maxRot = {};
        self.rotationPartTanknadel2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTanknadel2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTanknadel2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartTanknadel2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTanknadel2#rotTime"), 2)*1000;
        self.rotationPartTanknadel2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTanknadel2#touchRotLimit"), 10));
    end;




	local rotationPartNodePedal = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartPedal#index"));
    if rotationPartNodePedal ~= nil then
        self.rotationPartPedal = {};
        self.rotationPartPedal.node = rotationPartNodePedal;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartPedal#minRot"));
        self.rotationPartPedal.minRot = {};
        self.rotationPartPedal.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartPedal.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartPedal.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartPedal#maxRot"));
        self.rotationPartPedal.maxRot = {};
        self.rotationPartPedal.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartPedal.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartPedal.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartPedal.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartPedal#rotTime"), 2)*1000;
        self.rotationPartPedal.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartPedal#touchRotLimit"), 10));
    end;




local rotationPartNodeDrehzahl1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartDrehzahl1#index"));
    if rotationPartNodeDrehzahl1 ~= nil then
        self.rotationPartDrehzahl1 = {};
        self.rotationPartDrehzahl1.node = rotationPartNodeDrehzahl1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl1#minRot"));
        self.rotationPartDrehzahl1.minRot = {};
        self.rotationPartDrehzahl1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDrehzahl1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDrehzahl1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl1#maxRot"));
        self.rotationPartDrehzahl1.maxRot = {};
        self.rotationPartDrehzahl1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDrehzahl1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDrehzahl1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartDrehzahl1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl1#rotTime"), 2)*1000;
        self.rotationPartDrehzahl1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl1#touchRotLimit"), 10));
    end;
	
	local rotationPartNodeDrehzahl2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartDrehzahl2#index"));
    if rotationPartNodeDrehzahl2 ~= nil then
        self.rotationPartDrehzahl2 = {};
        self.rotationPartDrehzahl2.node = rotationPartNodeDrehzahl2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl2#minRot"));
        self.rotationPartDrehzahl2.minRot = {};
        self.rotationPartDrehzahl2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDrehzahl2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDrehzahl2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl2#maxRot"));
        self.rotationPartDrehzahl2.maxRot = {};
        self.rotationPartDrehzahl2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDrehzahl2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDrehzahl2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartDrehzahl2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl2#rotTime"), 2)*1000;
        self.rotationPartDrehzahl2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl2#touchRotLimit"), 10));
    end;

  local coverNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.cover#index"));
    if coverNode ~= nil then
        self.cover = {};
        self.cover.node = coverNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.cover#minRot"));
        self.cover.minRot = {};
        self.cover.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.cover.minRot[2] = Utils.degToRad(Utils.getNoNil(y, -90));
        self.cover.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.cover#maxRot"));
        self.cover.maxRot = {};
        self.cover.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.cover.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, -90));
        self.cover.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.cover.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.cover#rotTime"), 2)*1000;
        self.cover.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.cover#touchRotLimit"), 10));
    end;







      
    self.numWorklights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.worklights#count"), 0);
    self.worklights = {};
    for i=1, self.numWorklights do
        local worklightnamei = string.format("vehicle.worklights.worklight" .. "%d", i);
        self.worklights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, worklightnamei .. "#index"));
        setVisibility(self.worklights[i], false);
    end;	
	
	self.numbrakelights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.brakelights#count"), 0);
    self.brakelights = {};
    for i=1, self.numbrakelights do
        local brakelightnamei = string.format("vehicle.brakelights.brakelight" .. "%d", i);
        self.brakelights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, brakelightnamei .. "#index"));
        setVisibility(self.brakelights[i], false);
    end;
	self.brakelightsActive = false;
    self.braking = false;
	
	local radioSound = getXMLString(xmlFile, "vehicle.radioSound#file");
    if  radioSound ~= nil and  radioSound ~= "" then
        radioSound = Utils.getFilename( radioSound, self.baseDirectory); 
        self.radioSound = createSample(" radioSound");
        self.radioSoundPlaying = false;
        loadSample(self. radioSound, radioSound, false);
        self.radioSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.radioSound#volume"),1);
    end;


	
    self.rundumleuchtenAnz = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.rundumleuchten#count"),0);
    self.rundumleuchtenAn = false;
    self.rundumleuchten = {};
    for i=1, self.rundumleuchtenAnz do
        local objname = string.format("vehicle.rundumleuchten.light" .. "%d",i);
        self.rundumleuchten[i] = {};
        self.rundumleuchten[i].rotNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#rotNode"));
        self.rundumleuchten[i].light = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#light"));
        self.rundumleuchten[i].source = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#lightsource"));
        self.rundumleuchten[i].speed = Utils.getNoNil(getXMLInt(xmlFile,  objname .. "#rotSpeed"), 1)/1000;
        self.rundumleuchten[i].emit = Utils.getNoNil(getXMLBool(xmlFile, objname .. "#emitLight"), true);
        if not self.rundumleuchten[i].emit and self.rundumleuchten[i].source ~= nil then
           setVisibility(self.rundumleuchten[i].source, false);
        end;
    end;
	
	self.numFrontlights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.frontlights#count"), 0);
    self.frontlights = {};
    for i=1, self.numFrontlights do
        local frontlightnamei = string.format("vehicle.frontlights.frontlight" .. "%d", i);
        self.frontlights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, frontlightnamei .. "#index"));
        setVisibility(self.frontlights[i], false);
    end;	
 

	 self.numFarlights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.farlights#count"), 0);
    self.farlights = {};
    for i=1, self.numFarlights do
        local farlightnamei = string.format("vehicle.farlights.farlight" .. "%d", i);
        self.farlights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, farlightnamei .. "#index"));
        setVisibility(self.farlights[i], false);
    end;	
   




 local coverNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.cover#index"));
    if coverNode ~= nil then
        self.cover = {};
        self.cover.node = coverNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.cover#minRot"));
        self.cover.minRot = {};
        self.cover.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.cover.minRot[2] = Utils.degToRad(Utils.getNoNil(y, -90));
        self.cover.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.cover#maxRot"));
        self.cover.maxRot = {};
        self.cover.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.cover.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, -90));
        self.cover.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.cover.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.cover#rotTime"), 2)*1000;
        self.cover.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.cover#touchRotLimit"), 10));
    end;
	



	local rotationPartNodebackwindow = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.backwindow#index"));
    if rotationPartNodebackwindow ~= nil then
        self.rotationPartbackwindow = {};
        self.rotationPartbackwindow.node = rotationPartNodebackwindow;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartbackwindow#minRot"));
        self.rotationPartbackwindow.minRot = {};
        self.rotationPartbackwindow.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartbackwindow.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartbackwindow.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.backwindow#maxRot"));
        self.rotationPartbackwindow.maxRot = {};
        self.rotationPartbackwindow.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartbackwindow.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartbackwindow.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartbackwindow.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.backwindow#rotTime"), 2)*1000;
        self.rotationPartbackwindow.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.backwindow#touchRotLimit"), 10));
    end;

     local rotationPartNoderightdoor = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rightdoor#index"));
    if rotationPartNoderightdoor ~= nil then
        self.rotationPartrightdoor = {};
        self.rotationPartrightdoor.node = rotationPartNoderightdoor;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartrightdoor#minRot"));
        self.rotationPartrightdoor.minRot = {};
        self.rotationPartrightdoor.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartrightdoor.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartrightdoor.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rightdoor#maxRot"));
        self.rotationPartrightdoor.maxRot = {};
        self.rotationPartrightdoor.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartrightdoor.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartrightdoor.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartrightdoor.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rightdoor#rotTime"), 2)*1000;
        self.rotationPartrightdoor.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rightdoor#touchRotLimit"), 10));
    end;
	
	 local rotationPartNodeleftDoor = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.leftDoor#index"));
    if rotationPartNodeleftDoor ~= nil then
        self.rotationPartleftDoor = {};
        self.rotationPartleftDoor.node = rotationPartNodeleftDoor;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartleftDoor#minRot"));
        self.rotationPartleftDoor.minRot = {};
        self.rotationPartleftDoor.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartleftDoor.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartleftDoor.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.leftDoor#maxRot"));
        self.rotationPartleftDoor.maxRot = {};
        self.rotationPartleftDoor.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartleftDoor.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartleftDoor.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartleftDoor.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.leftDoor#rotTime"), 2)*1000;
        self.rotationPartleftDoor.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.leftDoor#touchRotLimit"), 10));
    end;
	local rotationPartNodeteto = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.teto#index"));
    if rotationPartNodeteto ~= nil then
        self.rotationPartteto = {};
        self.rotationPartteto.node = rotationPartNodeteto;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartteto#minRot"));
        self.rotationPartteto.minRot = {};
        self.rotationPartteto.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartteto.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartteto.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.teto#maxRot"));
        self.rotationPartteto.maxRot = {};
        self.rotationPartteto.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartteto.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartteto.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartteto.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.teto#rotTime"), 2)*1000;
        self.rotationPartteto.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.teto#touchRotLimit"), 10));
    end;
	local rotationPartNodeabl1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.abl1#index"));
    if rotationPartNodeabl1 ~= nil then
        self.rotationPartabl1 = {};
        self.rotationPartabl1.node = rotationPartNodeabl1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartabl1#minRot"));
        self.rotationPartabl1.minRot = {};
        self.rotationPartabl1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartabl1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartabl1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.abl1#maxRot"));
        self.rotationPartabl1.maxRot = {};
        self.rotationPartabl1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartabl1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartabl1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartabl1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.abl1#rotTime"), 2)*1000;
        self.rotationPartabl1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.abl1#touchRotLimit"), 10));
    end;
    local rotationPartNodeabl2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.abl2#index"));
    if rotationPartNodeabl2 ~= nil then
        self.rotationPartabl2 = {};
        self.rotationPartabl2.node = rotationPartNodeabl2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartabl2#minRot"));
        self.rotationPartabl2.minRot = {};
        self.rotationPartabl2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartabl2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartabl2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.abl2#maxRot"));
        self.rotationPartabl2.maxRot = {};
        self.rotationPartabl2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartabl2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartabl2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartabl2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.abl2#rotTime"), 2)*1000;
        self.rotationPartabl2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.abl2#touchRotLimit"), 10));
    end;
    local rotationPartNodehidra1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hidra1#index"));
    if rotationPartNodehidra1 ~= nil then
        self.rotationParthidra1 = {};
        self.rotationParthidra1.node = rotationPartNodehidra1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationParthidra1#minRot"));
        self.rotationParthidra1.minRot = {};
        self.rotationParthidra1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParthidra1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParthidra1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.hidra1#maxRot"));
        self.rotationParthidra1.maxRot = {};
        self.rotationParthidra1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParthidra1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParthidra1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationParthidra1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.hidra1#rotTime"), 2)*1000;
        self.rotationParthidra1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.hidra1#touchRotLimit"), 10));
    end;
        local rotationPartNodehidra2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hidra2#index"));
    if rotationPartNodehidra2 ~= nil then
        self.rotationParthidra2 = {};
        self.rotationParthidra2.node = rotationPartNodehidra2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationParthidra2#minRot"));
        self.rotationParthidra2.minRot = {};
        self.rotationParthidra2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParthidra2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParthidra2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.hidra2#maxRot"));
        self.rotationParthidra2.maxRot = {};
        self.rotationParthidra2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParthidra2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParthidra2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationParthidra2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.hidra2#rotTime"), 2)*1000;
        self.rotationParthidra2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.hidra2#touchRotLimit"), 10));
    end;
      local rotationPartNodehidra3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hidra3#index"));
    if rotationPartNodehidra3 ~= nil then
        self.rotationParthidra3 = {};
        self.rotationParthidra3.node = rotationPartNodehidra3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationParthidra3#minRot"));
        self.rotationParthidra3.minRot = {};
        self.rotationParthidra3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParthidra3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParthidra3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.hidra3#maxRot"));
        self.rotationParthidra3.maxRot = {};
        self.rotationParthidra3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParthidra3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParthidra3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationParthidra3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.hidra3#rotTime"), 2)*1000;
        self.rotationParthidra3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.hidra3#touchRotLimit"), 10));
    end;
    self.motorStopSoundVolume2 = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorStopSound#volume"), 1.0);
    hornSoundFile = Utils.getFilename("horn.wav", self.baseDirectory);
    self.hornSoundId = createSample("HupenSound");
    loadSample(self.hornSoundId, hornSoundFile, false);
    
    local motorMaxRpmStr = getXMLString(xmlFile, "vehicle.motor#maxRpm");
    local motorMaxRpm1, motorMaxRpm2, motorMaxRpm3 = Utils.getVectorFromString(motorMaxRpmStr);
    motorMaxRpm1 = Utils.getNoNil(motorMaxRpm1, 400);
    motorMaxRpm2 = Utils.getNoNil(motorMaxRpm2, 1300);
    motorMaxRpm3 = Utils.getNoNil(motorMaxRpm3, 2200);
    local motorMaxRpm = {motorMaxRpm1, motorMaxRpm2, motorMaxRpm3};
    self.motorMaxRpmLimit = motorMaxRpm;
    
	--[[Blinker start]]------------------------------------------------------------	
	turn1SoundFile = Utils.getFilename("sound/turn1.wav", self.baseDirectory);
    self.turn1 = createSample("turn1");
    loadSample(self.turn1, turn1SoundFile, false);
	turn2SoundFile = Utils.getFilename("sound/turn2.wav", self.baseDirectory);
    self.turn2 = createSample("turn2");
    loadSample(self.turn2, turn2SoundFile, false);	
	
    self.numTurnlights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.turnlights#count"), 0);
    self.turnlights = {};
    for i=1, self.numTurnlights do
        local turnlightnamei = string.format("vehicle.turnlights.turnlight" .. "%d", i);
        self.turnlights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, turnlightnamei .. "#index"));
        setVisibility(self.turnlights[i], false);
    end;	
	self.turnlightsActive = false;
	
    self.numTurnlights2 = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.turnlights2#count"), 0);
    self.turnlights2 = {};
    for i=1, self.numTurnlights2 do
        local turnlightnamei2 = string.format("vehicle.turnlights2.turnlight" .. "%d", i);
        self.turnlights2[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, turnlightnamei2 .. "#index"));
        setVisibility(self.turnlights2[i], false);
    end;	
	self.turnlightsActive2 = false;
--[[Blinker ende]]------------------------------------------------------------	

    self.keys = {};
    local i=0;
    while true do
        local baseName = string.format("vehicle.keys.input(%d)", i);
        local inputName = getXMLString(xmlFile, baseName.. "#name");
        if inputName == nil then
            break;
        end;
        local inputKey = getXMLString(xmlFile, baseName.. "#key");
        if Input[inputKey] == nil then
            print("Error: invalid key '" .. inputKey .. "'  for input event '" .. inputName .. "'");
            break;
        end;
        self.keys[inputName] = Input[inputKey];
        i = i+1;
    end;
	
	self.frontlights.outs = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.frontlights.frontlight#src"));
	
	self.farlightsActive = false;
    self.frontlightsActive = false;
	self.worklightsActive = false;
    self.hornPlaying = false;
    self.zuendungKey = true;
	self.allowedZuendung = true; 
    

end;

function superwse:keyEvent(unicode, sym, modifier, isDown)


if isDown and sym == Input.KEY_space then
		self.handbrake = not self.handbrake;
		if self.handbrake then
			playSample(self.handbrakeSoundId,1,1,0);
		end;
	end;


 if isDown and sym == Input.KEY_m then 
		self.drawfender = not self.drawfender;
		setVisibility(self.fender[1], self.drawfender);
    	setVisibility(self.fender[2], self.drawfender);
	end;



if isDown and sym == Input.KEY_v then
		if self.chuj then
			self.rotationMaxWajcha = true;
		else
			self.rotationMaxWajcha2 = true
		end;
	else
		self.rotationMaxWajcha = false;
		self.rotationMaxWajcha2 = false;
	end;


if isDown then
		if sym == Input.KEY_k then
			self.klaksonAllow = true;
		end;
	else
		self.klaksonAllow = false;
	end;



if isDown and sym == Input.KEY_r then
		self.radioOn = not self.radioOn;
	end;
	if isDown and sym == Input.KEY_t then
		stopSample(self.radio[self.currentSong].song);
		self.songPlayed = false;
		if self.currentSong >= self.radioCount then
			self.currentSong = 1;
		else
			self.currentSong = self.currentSong + 1;
		end;
	end;
	if isDown and sym == Input.KEY_y then
		stopSample(self.radio[self.currentSong].song);
		self.songPlayed = false;
		if self.currentSong <= 1 then
			self.currentSong = self.radioCount;
		else
			self.currentSong = self.currentSong - 1;
		end;
	end;


if isDown and sym == self.keys.tavolsagi then
	   if self.lighton then
		self.farLightActive = not self.farLightActive;
	   end;
	end;




    if isDown and sym == self.keys.rundumleuchte then
      self.rundumleuchtenAn = not self.rundumleuchtenAn;
      for i=1, self.rundumleuchtenAnz do
        setVisibility(self.rundumleuchten[i].light, self.rundumleuchtenAn);
      end;
    end;
    if isDown and sym == Input.KEY_l then
		self.worklightsActive = not self.worklightsActive;
		self.farlightsActive = false;
		self.frontlightsActive = false;
	end;
    if isDown and sym == Input.KEY_7 then
	    self.frontlightsActive = not self.frontlightsActive;
	    self.farlightsActive = false;
		self.worklightsActive = false;
	end;
	if isDown and sym == Input.KEY_8 then
		self.farlightsActive = not self.farlightsActive;
		self.frontlightsActive = false;
		self.worklightsActive = false;
	end;
    if isDown and sym == Input.KEY_0 then
		self.helpPanel = not self.helpPanel;
	end;
    if isDown and sym == Input.KEY_KP_5 then 
		self.rotationMaxbackwindow = not self.rotationMaxbackwindow;
	end; 
     if isDown and sym == Input.KEY_KP_1 then 
		self.rotationMaxrightdoor = not self.rotationMaxrightdoor;
	end; 
	 if isDown and sym == Input.KEY_KP_3 then 
		self.rotationMaxleftDoor = not self.rotationMaxleftDoor;
	end; 
	if isDown and sym == Input.KEY_KP_8 then 
		self.rotationMaxteto = not self.rotationMaxteto;
	end;
	if isDown and sym == Input.KEY_KP_4 then 
		self.rotationMaxabl1 = not self.rotationMaxabl1;
	end;
	if isDown and sym == Input.KEY_KP_6 then 
		self.rotationMaxabl2 = not self.rotationMaxabl2;
	end;
	if isDown and sym == Input.KEY_f5 then 
		self.rotationMaxhidra1 = not self.rotationMaxhidra1;
	end;
	if isDown and sym == Input.KEY_f6 then 
		self.rotationMaxhidra2 = not self.rotationMaxhidra2;
	end;
        	if isDown and sym == Input.KEY_f7 then 
		self.rotationMaxhidra3 = not self.rotationMaxhidra3;
        end;

if sym == Input.KEY_f8 then
		self.rotation1Min = isDown;
		self.translationHyd1Min = isDown;
		self.rotation3Min = isDown;
	end;
if sym == Input.KEY_f9 then
		self.rotation1Max = isDown;
		self.translationHyd1Max = isDown;
		self.rotation3Max = isDown;
	end;

if sym == Input.KEY_f10 then
		self.rotation1Min = isDown;
		self.translationHyd2Min = isDown;
		self.rotation3Min = isDown;
	end;
if sym == Input.KEY_f11 then
		self.rotation1Max = isDown;
		self.translationHyd2Max = isDown;
		self.rotation3Max = isDown;
	end;




if sym == Input.KEY_f10 then
		self.rotation1Min = isDown;
		self.translationHyd3Min = isDown;
		self.rotation3Min = isDown;
	end;
if sym == Input.KEY_f11 then
		self.rotation1Max = isDown;
		self.translationHyd3Max = isDown;
		self.rotation3Max = isDown;
	end;
if sym == Input.KEY_f10 then
		self.rotation1Min = isDown;
		self.translationHyd4Min = isDown;
		self.rotation3Min = isDown;
	end;
if sym == Input.KEY_f11 then
		self.rotation1Max = isDown;
		self.translationHyd4Max = isDown;
		self.rotation3Max = isDown;
	end;
if sym == Input.KEY_f10 then
		self.rotation1Min = isDown;
		self.translationHyd5Min = isDown;
		self.rotation3Min = isDown;
	end;
if sym == Input.KEY_f11 then
		self.rotation1Max = isDown;
		self.translationHyd5Max = isDown;
		self.rotation3Max = isDown;
	end;
if sym == Input.KEY_f10 then
		self.rotation1Min = isDown;
		self.translationHyd6Min = isDown;
		self.rotation3Min = isDown;
	end;
if sym == Input.KEY_f11 then
		self.rotation1Max = isDown;
		self.translationHyd6Max = isDown;
		self.rotation3Max = isDown;
	end;
if sym == Input.KEY_f10 then
		self.rotation1Min = isDown;
		self.translationHyd7Min = isDown;
		self.rotation3Min = isDown;
	end;
if sym == Input.KEY_f11 then
		self.rotation1Max = isDown;
		self.translationHyd7Max = isDown;
		self.rotation3Max = isDown;
	end;
if sym == Input.KEY_f10 then
		self.rotation1Min = isDown;
		self.translationHyd8Min = isDown;
		self.rotation3Min = isDown;
	end;
if sym == Input.KEY_f11 then
		self.rotation1Max = isDown;
		self.translationHyd8Max = isDown;
		self.rotation3Max = isDown;
	end;
if sym == Input.KEY_f10 then
		self.rotation1Min = isDown;
		self.translationHyd9Min = isDown;
		self.rotation3Min = isDown;
	end;
if sym == Input.KEY_f11 then
		self.rotation1Max = isDown;
		self.translationHyd9Max = isDown;
		self.rotation3Max = isDown;
	end;
if sym == Input.KEY_f10 then
		self.rotation1Min = isDown;
		self.translationHyd10Min = isDown;
		self.rotation3Min = isDown;
	end;
if sym == Input.KEY_f11 then
		self.rotation1Max = isDown;
		self.translationHyd10Max = isDown;
		self.rotation3Max = isDown;
	end;











if isDown and sym == self.keys.kiroWorkLight then
		self.workLightActive = not self.workLightActive;
	end;

if isDown and sym == self.keys.kiroBrushWindows then
		self.wiper1Active = not self.wiper1Active;
		self.wiper2Active = not self.wiper2Active;
	end;

	
	--[[Blinker start]]------------------------------------------------------------	
--[[Blinker Rechts]]-----------------------------------------------------------
	if isDown and sym == Input.KEY_f2 then
		self.flashLeft = not self.flashLeft;
		self.delayOnLeft = 10;
		self.flashRight = false;
		self.flash = false;
		self.flashlightsRightActive = false;
		self.flashlightsWarnerActive = false;
		self.flashlightsRight2Active = false;
		self.turnlightsActive2 = false;
		self.flashWarner = false;
	end;
--[[Warnblinker]]------------------------------------------------------------	
	if isDown and sym == Input.KEY_f3 then
		self.flash = not self.flash;
		self.flashRight = false;
		self.flashLeft = false;
		self.delayOn = 20;
		self.flashlightsRightActive = false;
		self.flashlightsLeftActive = false;
		self.flashWarner = not self.flashWarner;
	end;
--[[Blinker Links]]-----------------------------------------------------------
	if isDown and sym == Input.KEY_f4 then
		self.flashRight = not self.flashRight;
		self.delayOnRight = 10;
		self.flashLeft = false;
		self.flash = false;
		self.flashlightsLeftActive = false;
		self.flashlightsWarnerActive = false;
		self.flashlightsLeft2Active = false;
		self.turnlightsActive = false;
		self.flashWarner = false;
	end;	
--[[Blinker ende]]------------------------------------------------------------

end;




function superwse:update(dt)


  if self.isEntered then

       
		if not self.handbrake then
			brakeTorque = 0.00001;
			self.motor.brakeForce = brakeTorque;
			setVisibility(self.handbrakelight, false);
		else
			if not Input.isKeyPressed(Input.KEY_s) then
				brakeTorque = 50;
				self.motor.brakeForce = brakeTorque;
				acceleration = 0;
				setVisibility(self.handbrakelight, true);
			end;
		end;		
		if Input.isKeyPressed(Input.KEY_s) then
			if not self.druckWarning then
				if not self.braking then
					if self.attachedTrailer then
						self.druckLevel = self.druckLevel -350;
					else
						self.druckLevel = self.druckLevel -250;
					end;
					self.braking = true;
				end;
				brakeTorque = 20;
				setVisibility(self.brakelight, true);
				self.motor.brakeForce = brakeTorque;
				acceleration = 0;
				if not self.brakePlaying then
					playSample(self.brakeSoundId,1,1,0);
					self.brakePlaying = true;
				end;
				self.brakereleasePlaying = false;				
			end;
		else
			self.brakePlaying = false;
			setVisibility(self.brakelight, false);
			self.braking = false;
			if not self.handbrake then
				brakeTorque = 0.00001;
				self.motor.brakeForce = brakeTorque;
			end;
			if not self.brakereleasePlaying then
				playSample(self.brakereleaseSoundId,1,1,0);
				self.brakereleasePlaying = true;
			end;
		end;

        if self.firstTimeRun then
            WheelsUtil.updateWheelsPhysics(self, dt, self.lastSpeed, acceleration, false, self.requiredDriveMode)
        end;
		
		if self.fuelFillLevel < 50 then
			self.cos = self.cos - dt;
			if self.cos <= 0 then
				playSample(self.brakereleaseSoundId,1,1,0);
				self.cos = 20000;
			end;
		else
			self.cos = 20000;
		end;
		
		local ratio = 0;
		local rpmRange = 0;
		if self.gang02 then
			ratio = 6.5;
			rpmRange = 150;
			setVisibility(self.reverselight, true);
		elseif self.gang01 then
			ratio = 14;
			rpmRange = 300;
			setVisibility(self.reverselight, true);
		elseif self.gang0 then
			ratio = 0;
			setVisibility(self.reverselight, false);
		elseif self.gang1 then
			ratio = 15;
			rpmRange = 250;
			setVisibility(self.reverselight, false);
		elseif self.gang2 then
			ratio = 10;
			rpmRange = 200;
			setVisibility(self.reverselight, false);
		elseif self.gang3 then
			ratio = 7.5;
			rpmRange = 200;
			setVisibility(self.reverselight, false);
		elseif self.gang4 then
			ratio = 5.5;
			rpmRange = 200;
			setVisibility(self.reverselight, false);
		elseif self.gang5 then
			ratio = 4.0;
			rpmRange = 150;
			setVisibility(self.reverselight, false);
		elseif self.gang6 then
			ratio = 2.7;
			rpmRange = 1;
			setVisibility(self.reverselight, false);
		end;
		self.motor.backwardtestRatio = ratio;
		self.motor.forwardtestRatios = {ratio/2,ratio/1.5,ratio};
		self.motor.rpmFadeOutRange = rpmRange;
		
		
		if self.druckLevel >= -1 and self.druckLevel <= 6100 then
			self.compressorStart = true;
		end;
		if self.druckLevel >= 9999 then
			self.compressorStart = false;
		end;
		if self.compressorStart == true then
			if not self.compressorSoundRunning then
				playSample(self.compressorSoundId, 0, 1, 0);
				self.compressorSoundRunning = true;
			end;
			self.compressorstopSoundRunning = false;
			if self.druckLevel <= 10000 then
				self.druckLevel = self.druckLevel +(dt/3);
			end;
		end;
		if self.compressorStart == false then
			stopSample(self.compressorSoundId, 0, 1, 0);
			self.compressorSoundRunning = false;
			if not self.compressorstopSoundRunning then
				playSample(self.compressorStopSoundId, 1, 1, 0);
				self.compressorstopSoundRunning = true;
			end;
			if self.druckLevel >= 6099 then
				self.druckLevel = self.druckLevel -(dt/40);
			end;
		end;
		if self.druckLevel <= 6000 then
			self.druckWarning = true;
			self.drucklightActive = true;
		else
			self.druckWarning = false;
			self.drucklightActive = false;
		end;
	end;



if self.rotationPartWajcha ~= nil then
		local x, y, z = getRotation(self.rotationPartWajcha.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartWajcha.maxRot, self.rotationPartWajcha.minRot, 3, self.rotationPartWajcha.rotTime, dt, not self.rotationMaxWajcha);
		setRotation(self.rotationPartWajcha.node, unpack(newRot));
	end;

	if self.rotationPartWajcha2 ~= nil then
		local x, y, z = getRotation(self.rotationPartWajcha2.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartWajcha2.maxRot, self.rotationPartWajcha2.minRot, 3, self.rotationPartWajcha2.rotTime, dt, not self.rotationMaxWajcha2);
		setRotation(self.rotationPartWajcha2.node, unpack(newRot));
	end;



if Input.isKeyPressed(Input.KEY_0) then
		self.rotationMaxWajchaZaczep = true;
		self.rotationMaxWajchaZaczep2 = false;
	else
		self.rotationMaxWajchaZaczep = false;
	end;
	if Input.isKeyPressed(Input.KEY_9) then
		self.rotationMaxWajchaZaczep2 = true;
		self.rotationMaxWajchaZaczep = false;
	else
		self.rotationMaxWajchaZaczep2 = false;
	end;
	
	if self.rotationPartWajchaZaczep ~= nil then
		local x, y, z = getRotation(self.rotationPartWajchaZaczep.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartWajchaZaczep.maxRot, self.rotationPartWajchaZaczep.minRot, 3, self.rotationPartWajchaZaczep.rotTime, dt, not self.rotationMaxWajchaZaczep);
		setRotation(self.rotationPartWajchaZaczep.node, unpack(newRot));
	end;
	
	if self.rotationPartWajchaZaczep2 ~= nil then
		local x, y, z = getRotation(self.rotationPartWajchaZaczep2.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartWajchaZaczep2.maxRot, self.rotationPartWajchaZaczep2.minRot, 3, self.rotationPartWajchaZaczep2.rotTime, dt, not self.rotationMaxWajchaZaczep2);
		setRotation(self.rotationPartWajchaZaczep2.node, unpack(newRot));
	end;










if self.handbrake then
		self.rotationMaxReczny = true;
	else
		self.rotationMaxReczny = false;
	end;
if Input.isKeyPressed(Input.KEY_s) then
			self.rotationMaxBrake = true;
		else
			self.rotationMaxBrake = false;
		end;

if self.rotationPartBrake ~= nil then
		local x, y, z = getRotation(self.rotationPartBrake.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartBrake.maxRot, self.rotationPartBrake.minRot, 3, self.rotationPartBrake.rotTime, dt, not self.rotationMaxBrake);
		setRotation(self.rotationPartBrake.node, unpack(newRot));
	end;




if self.klaksonAllow and not self.klaksonPlaying then
		playSample(self.klaksonId,0,1,0);
		self.klaksonPlaying = true;
	elseif not self.klaksonAllow and self.klaksonPlaying then
		stopSample(self.klaksonId);
		self.klaksonPlaying = false;
	end;


if self.isEntered then
		if self.fuelFillLevel < 50 then
			self.tankwarn = self.tankwarn - dt;
			if self.tankwarn <= 0 then
				playSample(self.fuelwarningSoundId,1,1,0);
				self.tankwarn = 30000;
			end;
			self.tanklightActive = true;
		else
			self.tankwarn = 30000;
			self.tanklightActive = false;
		end;
		setVisibility(self.tanklight,self.tanklightActive);
		setVisibility(self.tank2light,self.tanklightActive);
	end;




if self.radioVolume <= 0 then
		self.radioVolume = 0.1;
	end;
	if self.radioOn then
		if not self.songPlayed then
			playSample(self.radio[self.currentSong].song, 1, self.radioVolume, 0);
			self.songKoniec = self.time + getSampleDuration(self.radio[self.currentSong].song);
			self.songPlayed = true;
		end;
		if self.time >= self.songKoniec then
			if self.currentSong == self.radioCount then
				self.currentSong = 1;
			else
				self.currentSong = self.currentSong + 1;
			end;
			self.songPlayed = false;
		end;
	else
		if self.songPlayed then
			stopSample(self.radio[self.currentSong].song, 0, 1, 0);
			self.songPlayed = false;
		end;
	end;



if not self.reverseLight then
		if self.movingDirection < 0 then
			self.backlightsActive = true;
		else
			self.backlightsActive = false;
		end;
	end;
	if self.backlightsActive then
		for i=1, self.numBacklights do
			local backlight = self.backlights[i];
			setVisibility(backlight, self.backlightsActive);
		end;
	else
		for i=1, self.numBacklights do
			local backlight = self.backlights[i];
			setVisibility(backlight, self.backlightsActive, false);
		end;
	end;


 if InputBinding.hasEvent(InputBinding.TOGGLE_LIGHTS) then
		if not self.farLightActive and not self.lighton then
			self.lighton = true;
		elseif not self.farLightActive and self.lighton then
			self.lighton = false;
		elseif self.farLightActive and self.lighton then
			self.lighton = false;
			self.farLightActive = false;
		end;
	end;
  if self.farLight ~= nil then
            if self.farLightActive then
            	setVisibility(self.farLight, self.farLightActive);
	    else
            	setVisibility(self.farLight, self.farLightActive);
	    end;
        end;











 if self.isEntered then

		if self.wiper1Active then
			if self.delayWischer1 >= 0 then
				self.delayWischer1 = self.delayWischer1 -dt;
			end;
			if self.delayWischer2 >= 0 then
				self.delayWischer2 = self.delayWischer2 -dt;
			end;
			if not self.wiper1Max then
				if self.delayWischer1 < 0 then
					self.delayWischer2 = 1000;
					self.wiper1Max = true;
					self.wiper2Max = true;
				end;
			end;
			if self.wiper1Max then
				if self.delayWischer2 < 0 then
					self.delayWischer1 = 1000;
					self.wiper1Max = false;
					self.wiper2Max = false;
				end;
			end;
		else
			self.wiper1Max = false;
			self.wiper2Max = false;
		end;

		

		if self.wiper1 ~= nil then
        	local x, y, z = getRotation(self.wiper1.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.wiper1.maxRot, self.wiper1.minRot, 3, self.wiper1.rotTime, dt, not self.wiper1Max);
        	setRotation(self.wiper1.node, unpack(newRot));
    	end;
		
		if self.wiper2 ~= nil then
        	local x, y, z = getRotation(self.wiper2.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.wiper2.maxRot, self.wiper2.minRot, 3, self.wiper2.rotTime, dt, not self.wiper2Max);
        	setRotation(self.wiper2.node, unpack(newRot));
    	end;

		local doRotate = self.armDownMax or self.armDownMin 
		if self.armDown ~= nil and doRotate then
        	local x, y, z = getRotation(self.armDown.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.armDown.maxRot, self.armDown.minRot, 3, self.armDown.rotTime, dt, not self.armDownMax);
        	setRotation(self.armDown.node, unpack(newRot));
		end;

		if  self.armHydr ~= nil and not self.armHydrMax and not self.armHydrMin  then
			setRotation(self.armHydr.node, 0, 0, 0);
		end;
		
		local doRotate = self.armHydrMax or self.armHydrMin 
		if self.armHydr ~= nil and doRotate then
        	local x, y, z = getRotation(self.armHydr.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.armHydr.maxRot, self.armHydr.minRot, 3, self.armHydr.rotTime, dt, not self.armHydrMax);
        	setRotation(self.armHydr.node, unpack(newRot));
		end;

		local doRotate = self.armUpMax or self.armUpMin 
		if self.armUp ~= nil and doRotate then
			local x, y, z = getRotation(self.armUp.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.armUp.maxRot, self.armUp.minRot, 3, self.armUp.rotTime, dt, not self.armUpMax);
			setRotation(self.armUp.node, unpack(newRot));
		end;

		local doRotate = self.cylinder1Max or self.cylinder1Min 
		if self.cylinder1 ~= nil and doRotate then
			local x, y, z = getRotation(self.cylinder1.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.cylinder1.maxRot, self.cylinder1.minRot, 3, self.cylinder1.rotTime, dt, not self.cylinder1Max);
			setRotation(self.cylinder1.node, unpack(newRot));
		end;

		local doRotate = self.rotBraceMax or self.rotBraceMin 
		if self.rotBrace ~= nil and doRotate then
			local x, y, z = getRotation(self.rotBrace.node);		
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.rotBrace.maxRot, self.rotBrace.minRot, 3, self.rotBrace.rotTime, dt, not self.rotBraceMax);
			setRotation(self.rotBrace.node, unpack(newRot));
		end;

		local doRotate = self.rotBrace2Max or self.rotBrace2Min 
		if self.rotBrace2 ~= nil and doRotate then
			local x, y, z = getRotation(self.rotBrace2.node);		
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.rotBrace2.maxRot, self.rotBrace2.minRot, 3, self.rotBrace2.rotTime, dt, not self.rotBrace2Max);
			setRotation(self.rotBrace2.node, unpack(newRot));
		end;
		
		local doTranslate = self.braceVertMax or self.braceVertMin 
		if self.braceVert ~= nil and doTranslate then 
			local x, y, z = getTranslation(self.braceVert.node); 
			local trans = {x,y,z}; 
			local newTrans = Utils.getMovedLimitedValues(trans, self.braceVert.maxTrans, self.braceVert.minTrans, 3, self.braceVert.transTime, dt, not self.braceVertMax); 
			setTranslation(self.braceVert.node, unpack(newTrans)); 
		end;

		local doTranslate = self.cylinder2Max or self.cylinder2Min 
		if self.cylinder2 ~= nil and doTranslate then 
			local x, y, z = getTranslation(self.cylinder2.node); 
			local trans = {x,y,z}; 
			local newTrans = Utils.getMovedLimitedValues(trans, self.cylinder2.maxTrans, self.cylinder2.minTrans, 3, self.cylinder2.transTime, dt, not self.cylinder2Max); 
			setTranslation(self.cylinder2.node, unpack(newTrans)); 
		end;

        if Input.isKeyPressed(self.keys.kiroShowBack) and self.camIndex == 2 then
                setCamera(self.backcamera);
       	end;

        self.input = InputBinding.getAnalogInputAxis(InputBinding.AXIS_FORWARD);
		if InputBinding.isAxisZero(self.input) then
        	self.input = InputBinding.getDigitalInputAxis(InputBinding.AXIS_FORWARD);
        end;

		if self.input == 1 and self.movingDirection > 0 then
			self.brakeLightActive = true;
		elseif self.input == -1 and self.movingDirection < 0 then
				self.brakeLightActive = true;
		else
			self.brakeLightActive = false;
		end;

      

	end;


















																		if self.rotationPartTanknadel ~= nil then
		local x, y, z = getRotation(self.rotationPartTanknadel.node);
		y = ((self.rotationPartTanknadel.maxRot[2] - self.rotationPartTanknadel.minRot[2]) / self.fuelCapacity) * self.fuelFillLevel + self.rotationPartTanknadel.minRot[2];
		setRotation(self.rotationPartTanknadel.node, x, y ,z);
	end;
	
	if self.rotationPartTanknadel2 ~= nil then
		local x, y, z = getRotation(self.rotationPartTanknadel2.node);
		y = ((self.rotationPartTanknadel2.maxRot[2] - self.rotationPartTanknadel2.minRot[2]) / self.fuelCapacity) * self.fuelFillLevel + self.rotationPartTanknadel2.minRot[2];
		setRotation(self.rotationPartTanknadel2.node, x, y ,z);
	end;

	local maxDruck = 10000;
	if self.rotationPartDruck ~= nil then
		local x, y, z = getRotation(self.rotationPartDruck.node);
	--	y = ((self.rotationPartDruck.maxRot[2] - self.rotationPartDruck.minRot[2]) / maxDruck) * self.druckLevel + self.rotationPartDruck.minRot[2];
		setRotation(self.rotationPartDruck.node, x, y ,z);
	end;
	
	local maxDruckLight = 10000;
	if self.rotationPartDruckLight ~= nil then
		local x, y, z = getRotation(self.rotationPartDruckLight.node);
	--	y = ((self.rotationPartDruckLight.maxRot[2] - self.rotationPartDruckLight.minRot[2]) / maxDruckLight) * self.druckLevel + self.rotationPartDruckLight.minRot[2];
		setRotation(self.rotationPartDruckLight.node, x, y ,z);
	end;
	
	local maxDrehzahl = 2800;
	if self.rotationPartDrehzahl1 ~= nil then
		local x, y, z = getRotation(self.rotationPartDrehzahl1.node);
		y = ((self.rotationPartDrehzahl1.maxRot[2] - self.rotationPartDrehzahl1.minRot[2]) / maxDrehzahl) * self.motor.lastMotorRpm + self.rotationPartDrehzahl1.minRot[2];
		setRotation(self.rotationPartDrehzahl1.node, x, y ,z);
	end;
	if self.rotationPartDrehzahl2 ~= nil then
		local x, y, z = getRotation(self.rotationPartDrehzahl2.node);
		y = ((self.rotationPartDrehzahl2.maxRot[2] - self.rotationPartDrehzahl2.minRot[2]) / maxDrehzahl) * self.motor.lastMotorRpm + self.rotationPartDrehzahl2.minRot[2];
		setRotation(self.rotationPartDrehzahl2.node, x, y ,z);
	end;
	
	local maxKmh = 100;
	if self.rotationPartKmh1 ~= nil then
		local x, y, z = getRotation(self.rotationPartKmh1.node);
		y = ((self.rotationPartKmh1.maxRot[2] - self.rotationPartKmh1.minRot[2]) / maxKmh) * self.lastSpeed*3600 + self.rotationPartKmh1.minRot[2];
		setRotation(self.rotationPartKmh1.node, x, y ,z);
	end;
	if self.rotationPartKmh2 ~= nil then
		local x, y, z = getRotation(self.rotationPartKmh2.node);
		y = ((self.rotationPartKmh2.maxRot[2] - self.rotationPartKmh2.minRot[2]) / maxKmh) * self.lastSpeed*3600 + self.rotationPartKmh2.minRot[2];
		setRotation(self.rotationPartKmh2.node, x, y ,z);
	end;
	
	if self.isEntered then
		if Input.isKeyPressed(Input.KEY_w) then
			self.rotationMaxPedal = true;
		else
			self.rotationMaxPedal = false;
		end;
		if Input.isKeyPressed(Input.KEY_s) then
			self.rotationMaxBrake = true;
		else
			self.rotationMaxBrake = false;
		end;
		if self.gang0 then
			self.rotationMaxClutch = true;
		else
			self.rotationMaxClutch = false;
		end;
																										end

																					if self.isEntered then
		if Input.isKeyPressed(Input.KEY_w) then
			self.rotationMaxPedal = true;
		else
			self.rotationMaxPedal = false;
		end;
		if Input.isKeyPressed(Input.KEY_s) then
			self.rotationMaxBrake = true;
		else
			self.rotationMaxBrake = false;
		end;
		if self.gang0 then
			self.rotationMaxClutch = true;
		else
			self.rotationMaxClutch = false;
		end;
	end
	
	if self.rotationPartPedal ~= nil then
		local x, y, z = getRotation(self.rotationPartPedal.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartPedal.maxRot, self.rotationPartPedal.minRot, 3, self.rotationPartPedal.rotTime, dt, not self.rotationMaxPedal);
		setRotation(self.rotationPartPedal.node, unpack(newRot));
																										end;



																					local maxDrehzahl = 1800;
	if self.rotationPartDrehzahl1 ~= nil then
		local x, y, z = getRotation(self.rotationPartDrehzahl1.node);
		y = ((self.rotationPartDrehzahl1.maxRot[2] - self.rotationPartDrehzahl1.minRot[2]) / maxDrehzahl) * self.motor.lastMotorRpm + self.rotationPartDrehzahl1.minRot[2];
		setRotation(self.rotationPartDrehzahl1.node, x, y ,z);
	end;
	if self.rotationPartDrehzahl2 ~= nil then
		local x, y, z = getRotation(self.rotationPartDrehzahl2.node);
		y = ((self.rotationPartDrehzahl2.maxRot[2] - self.rotationPartDrehzahl2.minRot[2]) / maxDrehzahl) * self.motor.lastMotorRpm + self.rotationPartDrehzahl2.minRot[2];
		setRotation(self.rotationPartDrehzahl2.node, x, y ,z);
																										end;




													 if self.motor.lastMotorRpm > 750 and self.isEntered then

		if self.cover ~= nil then
        	local x, y, z = getRotation(self.cover.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.cover.maxRot, self.cover.minRot, 3, self.cover.rotTime, dt, self.isEntered);
        	setRotation(self.cover.node, unpack(newRot));
    	end;
        Utils.setEmittingState(self.exhaustParticleSystemextra, true)
		if self.motor.lastMotorRpm > 1300 then
			Utils.setEmittingState(self.exhaustParticleSystemextra1, true)
		else
			Utils.setEmittingState(self.exhaustParticleSystemextra1, false)
		end;						
    elseif self.isEntered then
		self.covermove = math.random(300,1300);
		if self.cover ~= nil then
        	local x, y, z = getRotation(self.cover.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, {80,0,0}, {self.covermove*0.001,0,0}, 3, 60000, dt, self.isEntered);
        	setRotation(self.cover.node, unpack(newRot));
    	end;
        Utils.setEmittingState(self.exhaustParticleSystemextra1, false)
        Utils.setEmittingState(self.exhaustParticleSystemextra, false)
        Utils.setEmittingState(self.exhaustParticleSystem, true)
    else
		if self.isAITractorActivated then
			if self.cover ~= nil then
        		local x, y, z = getRotation(self.cover.node);
        		local rot = {x,y,z};
        		local newRot = Utils.getMovedLimitedValues(rot, self.cover.maxRot, self.cover.minRot, 3, self.cover.rotTime, dt, true);
        		setRotation(self.cover.node, unpack(newRot));
    		end;
			Utils.setEmittingState(self.exhaustParticleSystemextra, true)
		else
			if self.cover ~= nil then
        		local x, y, z = getRotation(self.cover.node);
        		local rot = {x,y,z};
        		local newRot = Utils.getMovedLimitedValues(rot, self.cover.maxRot, self.cover.minRot, 3, self.cover.rotTime, dt, false);
        		setRotation(self.cover.node, unpack(newRot));
    		end;
		end;
  																									  end;



if self.crankshaftNode ~= nil and (self.movingDirection > 0 or self.movingDirection < 0) then
         	rotate(self.crankshaftNode, 0, 0, self.motor.lastMotorRpm*0.001);
    	end;
if self.crankshaft1Node ~= nil and (self.movingDirection > 0 or self.movingDirection < 0) then
         	rotate(self.crankshaft1Node, 0, 0, self.motor.lastMotorRpm*0.001);
    	end;
if self.crankshaft2Node ~= nil and (self.movingDirection > 0 or self.movingDirection < 0) then
         	rotate(self.crankshaft2Node, 0, 0, self.motor.lastMotorRpm*0.001);
    	end;	
if self.crankshaft3Node ~= nil and (self.movingDirection > 0 or self.movingDirection < 0) then
         	rotate(self.crankshaft3Node, 0, 0, self.motor.lastMotorRpm*0.001);
    	end;	
if self.crankshaft4Node ~= nil and (self.movingDirection > 0 or self.movingDirection < 0) then
         	rotate(self.crankshaft4Node, 0, 0, self.motor.lastMotorRpm*0.001);
    	end;
if self.crankshaft5Node ~= nil and (self.movingDirection > 0 or self.movingDirection < 0) then
         	rotate(self.crankshaft5Node, 0, 0, self.motor.lastMotorRpm*0.001);
    	end;
if self.crankshaft6Node ~= nil and (self.movingDirection > 0 or self.movingDirection < 0) then
         	rotate(self.crankshaft6Node, 0, 0, self.motor.lastMotorRpm*0.001);
    	end;
if self.crankshaft7Node ~= nil and (self.movingDirection > 0 or self.movingDirection < 0) then
         	rotate(self.crankshaft7Node, 0, 0, self.motor.lastMotorRpm*0.001);
    	end;
if self.crankshaft8Node ~= nil and (self.movingDirection > 0 or self.movingDirection < 0) then
         	rotate(self.crankshaft8Node, 0, 0, self.motor.lastMotorRpm*0.001);
    	end;
if self.crankshaft9Node ~= nil and (self.movingDirection > 0 or self.movingDirection < 0) then
         	rotate(self.crankshaft9Node, 0, 0, self.motor.lastMotorRpm*0.001);
    	end;
if self.crankshaft10Node ~= nil and (self.movingDirection > 0 or self.movingDirection < 0) then
         	rotate(self.crankshaft10Node, 0, 0, self.motor.lastMotorRpm*0.001);
    	end;
if self.crankshaft11Node ~= nil and (self.movingDirection > 0 or self.movingDirection < 0) then
         	rotate(self.crankshaft11Node, 0, 0, self.motor.lastMotorRpm*0.001);
    	end;
if self.crankshaft12Node ~= nil and (self.movingDirection > 0 or self.movingDirection < 0) then
         	rotate(self.crankshaft12Node, 0, 0, self.motor.lastMotorRpm*0.001);
    	end;




  if self.workLight ~= nil then
            if self.workLightActive then
            	setVisibility(self.workLight, self.workLightActive);
			else
            	setVisibility(self.workLight, self.workLightActive);
			end;
        end;








local doTranslate = self.translationHyd1Max or self.translationHyd1Min 
	if self.translationHyd1 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationHyd1.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationHyd1.maxTrans, self.translationHyd1.minTrans, 3, self.translationHyd1.transTime, dt, not self.translationHyd1Max); 
		setTranslation(self.translationHyd1.node, unpack(newTrans)); 
	end;	

local doTranslate = self.translationHyd2Max or self.translationHyd2Min 
	if self.translationHyd2 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationHyd2.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationHyd2.maxTrans, self.translationHyd2.minTrans, 3, self.translationHyd2.transTime, dt, not self.translationHyd2Max); 
		setTranslation(self.translationHyd2.node, unpack(newTrans)); 
	end;	



local doTranslate = self.translationHyd3Max or self.translationHyd3Min 
	if self.translationHyd3 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationHyd3.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationHyd3.maxTrans, self.translationHyd3.minTrans, 3, self.translationHyd3.transTime, dt, not self.translationHyd3Max); 
		setTranslation(self.translationHyd3.node, unpack(newTrans)); 
	end;	
local doTranslate = self.translationHyd4Max or self.translationHyd4Min 
	if self.translationHyd4 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationHyd4.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationHyd4.maxTrans, self.translationHyd4.minTrans, 3, self.translationHyd4.transTime, dt, not self.translationHyd4Max); 
		setTranslation(self.translationHyd4.node, unpack(newTrans)); 
	end;	
local doTranslate = self.translationHyd5Max or self.translationHyd5Min 
	if self.translationHyd5 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationHyd5.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationHyd5.maxTrans, self.translationHyd5.minTrans, 3, self.translationHyd5.transTime, dt, not self.translationHyd5Max); 
		setTranslation(self.translationHyd5.node, unpack(newTrans)); 
	end;	
local doTranslate = self.translationHyd6Max or self.translationHyd6Min 
	if self.translationHyd6 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationHyd6.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationHyd6.maxTrans, self.translationHyd6.minTrans, 3, self.translationHyd6.transTime, dt, not self.translationHyd6Max); 
		setTranslation(self.translationHyd6.node, unpack(newTrans)); 
	end;	
local doTranslate = self.translationHyd7Max or self.translationHyd7Min 
	if self.translationHyd7 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationHyd7.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationHyd7.maxTrans, self.translationHyd7.minTrans, 3, self.translationHyd7.transTime, dt, not self.translationHyd7Max); 
		setTranslation(self.translationHyd7.node, unpack(newTrans)); 
	end;	
local doTranslate = self.translationHyd8Max or self.translationHyd8Min 
	if self.translationHyd8 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationHyd8.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationHyd8.maxTrans, self.translationHyd8.minTrans, 3, self.translationHyd8.transTime, dt, not self.translationHyd8Max); 
		setTranslation(self.translationHyd8.node, unpack(newTrans)); 
	end;	
local doTranslate = self.translationHyd9Max or self.translationHyd9Min 
	if self.translationHyd9 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationHyd9.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationHyd9.maxTrans, self.translationHyd9.minTrans, 3, self.translationHyd9.transTime, dt, not self.translationHyd9Max); 
		setTranslation(self.translationHyd9.node, unpack(newTrans)); 
	end;	
local doTranslate = self.translationHyd10Max or self.translationHyd10Min 
	if self.translationHyd10 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationHyd10.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationHyd10.maxTrans, self.translationHyd10.minTrans, 3, self.translationHyd10.transTime, dt, not self.translationHyd10Max); 
		setTranslation(self.translationHyd10.node, unpack(newTrans)); 
	end;	





























 if self.motor.lastMotorRpm > 750 and self.isEntered then

		if self.cover ~= nil then
        	local x, y, z = getRotation(self.cover.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.cover.maxRot, self.cover.minRot, 3, self.cover.rotTime, dt, self.isEntered);
        	setRotation(self.cover.node, unpack(newRot));
    	end;
        Utils.setEmittingState(self.exhaustParticleSystemextra, true)
		if self.motor.lastMotorRpm > 1300 then
			Utils.setEmittingState(self.exhaustParticleSystemextra1, true)
		else
			Utils.setEmittingState(self.exhaustParticleSystemextra1, false)
		end;						
    elseif self.isEntered then
		self.covermove = math.random(300,1300);
		if self.cover ~= nil then
        	local x, y, z = getRotation(self.cover.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, {80,0,0}, {self.covermove*0.001,0,0}, 3, 60000, dt, self.isEntered);
        	setRotation(self.cover.node, unpack(newRot));
    	end;
        Utils.setEmittingState(self.exhaustParticleSystemextra1, false)
        Utils.setEmittingState(self.exhaustParticleSystemextra, false)
        Utils.setEmittingState(self.exhaustParticleSystem, true)
    else
		if self.isAITractorActivated then
			if self.cover ~= nil then
        		local x, y, z = getRotation(self.cover.node);
        		local rot = {x,y,z};
        		local newRot = Utils.getMovedLimitedValues(rot, self.cover.maxRot, self.cover.minRot, 3, self.cover.rotTime, dt, true);
        		setRotation(self.cover.node, unpack(newRot));
    		end;
			Utils.setEmittingState(self.exhaustParticleSystemextra, true)
		else
			if self.cover ~= nil then
        		local x, y, z = getRotation(self.cover.node);
        		local rot = {x,y,z};
        		local newRot = Utils.getMovedLimitedValues(rot, self.cover.maxRot, self.cover.minRot, 3, self.cover.rotTime, dt, false);
        		setRotation(self.cover.node, unpack(newRot));
    		end;
		end;
    end;



    if self.isEntered then
	
	    if self.rotationPartbackwindow ~= nil then
		   local x, y, z = getRotation(self.rotationPartbackwindow.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartbackwindow.maxRot, self.rotationPartbackwindow.minRot, 3, self.rotationPartbackwindow.rotTime, dt, not self.rotationMaxbackwindow);
		   setRotation(self.rotationPartbackwindow.node, unpack(newRot));
        end;

        if self.rotationPartleftDoor ~= nil then
		   local x, y, z = getRotation(self.rotationPartleftDoor.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartleftDoor.maxRot, self.rotationPartleftDoor.minRot, 3, self.rotationPartleftDoor.rotTime, dt, not self.rotationMaxleftDoor);
		   setRotation(self.rotationPartleftDoor.node, unpack(newRot));
        end;
    
       if self.rotationPartteto ~= nil then
		   local x, y, z = getRotation(self.rotationPartteto.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartteto.maxRot, self.rotationPartteto.minRot, 3, self.rotationPartteto.rotTime, dt, not self.rotationMaxteto);
		   setRotation(self.rotationPartteto.node, unpack(newRot));
        end;
        
	    if self.rotationPartrightdoor ~= nil then
		   local x, y, z = getRotation(self.rotationPartrightdoor.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartrightdoor.maxRot, self.rotationPartrightdoor.minRot, 3, self.rotationPartrightdoor.rotTime, dt, not self.rotationMaxrightdoor);
		   setRotation(self.rotationPartrightdoor.node, unpack(newRot));
        end;
		if self.rotationPartabl1 ~= nil then
		   local x, y, z = getRotation(self.rotationPartabl1.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartabl1.maxRot, self.rotationPartabl1.minRot, 3, self.rotationPartabl1.rotTime, dt, not self.rotationMaxabl1);
		   setRotation(self.rotationPartabl1.node, unpack(newRot));
        end;
        if self.rotationPartabl2 ~= nil then
		   local x, y, z = getRotation(self.rotationPartabl2.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartabl2.maxRot, self.rotationPartabl2.minRot, 3, self.rotationPartabl2.rotTime, dt, not self.rotationMaxabl2);
		   setRotation(self.rotationPartabl2.node, unpack(newRot));
        end;
        if self.rotationParthidra1 ~= nil then
		   local x, y, z = getRotation(self.rotationParthidra1.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationParthidra1.maxRot, self.rotationParthidra1.minRot, 3, self.rotationParthidra1.rotTime, dt, not self.rotationMaxhidra1);
		   setRotation(self.rotationParthidra1.node, unpack(newRot));
        end;
        if self.rotationParthidra2 ~= nil then
		   local x, y, z = getRotation(self.rotationParthidra2.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationParthidra2.maxRot, self.rotationParthidra2.minRot, 3, self.rotationParthidra2.rotTime, dt, not self.rotationMaxhidra2);
		   setRotation(self.rotationParthidra2.node, unpack(newRot));
        end;
        if self.rotationParthidra3 ~= nil then
		   local x, y, z = getRotation(self.rotationParthidra3.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationParthidra3.maxRot, self.rotationParthidra3.minRot, 3, self.rotationParthidra3.rotTime, dt, not self.rotationMaxhidra3);
		   setRotation(self.rotationParthidra3.node, unpack(newRot));
        end;
	



	
	    if self.isEntered then
        if self.worklightsActive then
		   for i=1, self.numWorklights do
		   local worklight = self.worklights[i];
		   setVisibility(worklight, self.worklightsActive);
		end;
	else
		for i=1, self.numWorklights do
			local worklight = self.worklights[i];
			setVisibility(worklight, self.worklightsActive, false);
		end;
	end;
	end;
	    
		if self.isEntered then
		  if self.frontlightsActive then
		   for i=1, self.numFrontlights do
		   local frontlight = self.frontlights[i];
		   setVisibility(frontlight, self.frontlightsActive);
		end;
	else
		for i=1, self.numFrontlights do
			local frontlight = self.frontlights[i];
			setVisibility(frontlight, self.frontlightsActive, false);
			setVisibility(self.frontlights.outs, true);
		end;
	end;
	end;
	end;
	
		if self.isEntered then
        if self.farlightsActive then
		   for i=1, self.numFarlights do
		   local farlight = self.farlights[i];
		   setVisibility(farlight, self.farlightsActive);
		end;
	else 
	    if not self.farlightsActive then
		for i=1, self.numFarlights do
			local farlight = self.farlights[i];
			setVisibility(farlight, self.farlightsActive, false);
		end;
	end;
 end;


        if self.isEntered then
          if self.frontlightsActive then
            setVisibility(self.frontlights.outs, false);
          else
            setVisibility(self.frontlights.outs, true);
          end;
        end;
		
         if self:getIsActiveForInput() and self:getIsActiveForSound() and InputBinding.hasEvent(InputBinding.RADIO) then
             if not self.radioSoundPlaying then 
               playSample(self. radioSound, 0, self. radioSoundVolume, 0); 
               self.radioSoundPlaying = true; 
           else 
                stopSample(self. radioSound); 
                self.radioSoundPlaying = false; 
             end;  
          end;

        inputAxisY = InputBinding.getAnalogInputAxis(InputBinding.AXIS_FORWARD);

        if InputBinding.isAxisZero(inputAxisY) then
        inputAxisY = InputBinding.getDigitalInputAxis(InputBinding.AXIS_FORWARD);
        end;
			
		if self.isEntered ~= nil then
		if self.brakelightsActive then
			for i=1, self.numbrakelights do
				local brakelight = self.brakelights[i];
				setVisibility(brakelight, self.brakelightsActive);
			end;
		else
			for i=1, self.numbrakelights do
				local brakelight = self.brakelights[i];
				setVisibility(brakelight, self.brakelightsActive, false);
			end;
		end;
		if (self.movingDirection*self.lastSpeed*(-inputAxisY)) < -0.001 then		
			self.brakelightsActive = true;
			self.braking = true;
		else
			self.brakelightsActive = false;
			self.braking = false;
		end;
    end;
		  
		if self:getIsActiveForInput() and self:getIsActiveForSound() and InputBinding.isPressed(InputBinding.HUPE) then
        if not self.hornPlaying then
            playSample(self.hornSoundId, 0, 1, 0);
            self.hornPlaying = true;
        end;
    else
        if self.hornPlaying then
            stopSample(self.hornSoundId);
            self.hornPlaying = false;
        end;
    end;

        if self.rundumleuchtenAn then
          for i=1, self.rundumleuchtenAnz do
            rotate(self.rundumleuchten[i].rotNode, 0, dt*self.rundumleuchten[i].speed, 0);
          end;
        end;
        
		if g_currentMission.environment ~= nil and g_currentMission.environment.dayNightCycle and
              (g_currentMission.environment.dayTime > (20.5*1000*60*60) or g_currentMission.environment.dayTime < (5.5*1000*60*60)) and
              not self.lightsActive and self.isHired and not self.steeringEnabled then
		self.lightsActive = true;
	end;

	if not self.isHired and self.lightsActive and not self.isEntered or not g_currentMission.environment.dayNightCycle then
		self.lightsActive = false;
	end;


    for k, light in pairs(self.lights) do
        setVisibility(light, self.lightsActive);
    end; 
    

    if not self.isAITractorActivated then
       
        if self:getIsActiveForInput() then
            if InputBinding.hasEvent(InputBinding.ZUENDUNG) then
		        self.zuendungKey = not self.zuendungKey;
			    self.allowedZuendung = true;
	        end;
	    end;
		
	    
	    if not self.allowedZuendung and  not self.zuendungKey then
            self.isMotorStarted = true;
            Motorized.stopSounds(self);
	        self.steeringEnabled = true;
            Utils.setEmittingState(self.exhaustParticleSystems, true)
	    end;
	
	   
	    if not self.zuendungKey then
	        self.motorStopSoundVolume = 0;
        else
	        self.motorStopSoundVolume = self.motorStopSoundVolume2;
	    end;
		
	    
	    if self.allowedZuendung then
	        if  not self.zuendungKey then
		        self.motorStopSoundVolume = self.motorStopSoundVolume2;
                self:stopMotor();
			    self.steeringEnabled = true;
                self.allowedZuendung = true;	
		
			    
                for k,wheel in pairs(self.wheels) do
                    setWheelShapeProps(wheel.node, wheel.wheelShape, 0, self.motor.brakeForce, 0);
                end;
                self:onDeactivateAttachements();
	        elseif self.zuendungKey then
                self:startMotor();
                self.steeringEnabled = true;
                self.allowedZuendung = true;		
       	    end;
	    end;
   
    elseif not self.zuendungKey and not self.deactivateOnLeave then
		self:stopAITractor();
	end;


end;
    if self.isMotorStarted and self:getIsActiveForInput() and self.isEntered then
	
	    if self.motor.speedLevel ~= 0 then
			
            if InputBinding.isPressed(InputBinding.ACCELERATE) then
		        if self.motor.maxRpm[self.motor.speedLevel] <= (self.motorMaxRpmLimit[3] - 10) then
		            self.motor.maxRpm[self.motor.speedLevel] = self.motor.maxRpm[self.motor.speedLevel] + 10;
			    end;
		    elseif InputBinding.isPressed(InputBinding.DECELERATE) then
		        if self.motor.maxRpm[self.motor.speedLevel] >= 10 then
			        self.motor.maxRpm[self.motor.speedLevel] = self.motor.maxRpm[self.motor.speedLevel] - 10;
			    end;
	    	end;
				
		else
			
            if InputBinding.isPressed(InputBinding.ACCELERATE) then
		        if self.motor.maxRpm[3] <= (self.motorMaxRpmLimit[3] - 10) then
		            self.motor.maxRpm[3] = self.motor.maxRpm[3] + 10;
			    end;
		    elseif InputBinding.isPressed(InputBinding.DECELERATE) then
		        if self.motor.maxRpm[3] >= 10 then
			            self.motor.maxRpm[3] = self.motor.maxRpm[3] - 10;
			    end;
	    	end;
		end;
	end;
	
	
--[[Blinker start]]------------------------------------------------------------
	    if self.flash then
		    if self.delayOn >= 0 then
			    self.delayOn = self.delayOn -dt;
		    end;
		    if not self.flashlightsRightActive then
			    if self.delayOn < 0 then
				    self.delayOff = 500;
				    self.flashlightsRightActive = true;
				    self.flashlightsLeftActive = true;
			    	self.flashlightsWarnerActive = true;
				    self.turnlightsActive2 = true;
			    	self.turnlightsActive = true;
				    playSample(self.turn1, 1, 0.7, 0);
			    end;
		    end;
		if self.delayOff >= 0 then
			self.delayOff = self.delayOff -dt;
		end;
		if self.flashlightsRightActive then
			if self.delayOff < 0 then
				self.delayOn = 500;
				self.flashlightsLeftActive = false;
				self.flashlightsRightActive = false;
				self.flashlightsWarnerActive = false;
				self.turnlightsActive2 = false;
				self.turnlightsActive = false;
				playSample(self.turn2, 1, 0.7, 0);
			end;
		end;
	  end;

	    if self.flashRight then
		    if self.delayOnRight >= 0 then
			    self.delayOnRight = self.delayOnRight -dt;
		    end;
		    if not self.flashlightsRightActive then
			    if self.delayOnRight < 0 then
				    self.delayOffRight = 500;
				    self.flashlightsRightActive = true;
				    self.turnlightsActive2 = true;
				    playSample(self.turn1,1,0.7,0);
			    end;
		    end;
		    if self.delayOffRight >= 0 then
			   self.delayOffRight = self.delayOffRight -dt;
		    end;
		    if self.flashlightsRightActive then
			    if self.delayOffRight < 0 then
				    self.delayOnRight = 500;
				    self.flashlightsRightActive = false;
				    self.turnlightsActive2 = false;
				    playSample(self.turn2,1,0.7,0);
			    end;
		    end;
	    else
		    if not self.flashWarner then
			    self.turnlightsActive2 = false;
		    end;
	    end;

		if self.flashLeft then
			if self.delayOnLeft >= -1 then
				self.delayOnLeft = self.delayOnLeft -dt;
			end;
			if not self.flashlightsLeftActive then
				if self.delayOnLeft < 0 then
					self.delayOffLeft = 500;
					self.flashlightsLeftActive = true;
					self.turnlightsActive = true;
					playSample(self.turn1,1,0.7,0);
				end;
			end;
			if self.delayOffLeft >= 0 then
				self.delayOffLeft = self.delayOffLeft -dt;
			end;
			if self.flashlightsLeftActive then
				if self.delayOffLeft < 0 then
					self.delayOnLeft = 500;
					self.flashlightsLeftActive = false;
					self.turnlightsActive = false;
					playSample(self.turn2,1,0.7,0);
				end;
			end;
		else
			if not self.flashWarner then
				self.turnlightsActive = false;
			end;
		end;

		if self.turnlightsActive then
			for i=1, self.numTurnlights do
				local turnlight = self.turnlights[i];
				setVisibility(turnlight, self.turnlightsActive);
			end;
		else
			for i=1, self.numTurnlights do
				local turnlight = self.turnlights[i];
				setVisibility(turnlight, self.turnlightsActive, false);
			end;
		end;
    	if self.turnlightsActive2 then
			for i=1, self.numTurnlights2 do
				local turnlight2 = self.turnlights2[i];
				setVisibility(turnlight2, self.turnlightsActive2);
			end;
		else
			for i=1, self.numTurnlights2 do
				local turnlight2 = self.turnlights2[i];
				setVisibility(turnlight2, self.turnlightsActive2, false);
			end;
		end;
	
--[[Blinker ende]]------------------------------------------------------------

end;

function superwse:draw()


	if self.isEntered then
		if self.hudjohndeereOverlay ~= nil then
			self.hudjohndeereOverlay:render();
		end;
		if self.handbrake then
			setTextBold(true);
			setTextColor(1,0,0,1);
			if Input.isKeyPressed(Input.KEY_w) then
				setTextBold(true);
				setTextColor(1,0,0,1);
				renderText(0.5, 0.5, 0.05, "ruhnik");
			end;
			renderText(0.8335, 0.22, 0.02, "(!) Handbremse");	
		end;
		
		
		if self.druckWarning then
			setTextBold(true);
			setTextColor(1,0,0,1);
			renderText(0.8335, 0.232, 0.02, "Bremsdruck zu gering!");
		end;
	end;



local maxDruck = 10000;
	if self.rotationPartDruck ~= nil then
		local x, y, z = getRotation(self.rotationPartDruck.node);
		y = ((self.rotationPartDruck.maxRot[2] - self.rotationPartDruck.minRot[2]) / maxDruck) * self.druckLevel + self.rotationPartDruck.minRot[2];
		setRotation(self.rotationPartDruck.node, x, y ,z);
	end;
	
	local maxDruckLight = 10000;
	if self.rotationPartDruckLight ~= nil then
		local x, y, z = getRotation(self.rotationPartDruckLight.node);
		y = ((self.rotationPartDruckLight.maxRot[2] - self.rotationPartDruckLight.minRot[2]) / maxDruckLight) * self.druckLevel + self.rotationPartDruckLight.minRot[2];
		setRotation(self.rotationPartDruckLight.node, x, y ,z);
	end;

setVisibility(self.drucklight,self.drucklightActive);
	setVisibility(self.druck2light,self.drucklightActive);
	setVisibility(self.druck3light,not self.drucklightActive);





    if self.isEntered then
		if not self.helpPanel then
			renderText(0.8335, 0.20, 0.02, "Taste 0: jcb2170 Info");
		else
			renderText(0.8335, 0.20, 0.02, "Taste 0: jcb2170 Info");
		end;
		if self.helpPanel then
			renderText(0.72, 0.84, 0.025, "- jcb2170 Info -");
			renderText(0.72, 0.82, 0.02, "num 1: leftdoor");		
			renderText(0.72, 0.80, 0.02, "num 3: rightdoor");
			renderText(0.72, 0.78, 0.02, "num 4: luk");
			renderText(0.72, 0.76, 0.02, "num 6: zadwindows'");
                        renderText(0.72, 0.74, 0.02, "num 2 : dworniki");
			renderText(0.72, 0.72, 0.02, "num 5 : bagajnik");
			renderText(0.72, 0.70, 0.02, "num 8 : kapot");
                        renderText(0.72, 0.68, 0.02, "num 9 : swet");
renderText(0.72, 0.66, 0.02, "f2 : leftpoworotnik");
renderText(0.72, 0.64, 0.02, "f4 : rightpoworotnik");
renderText(0.72, 0.62, 0.02, "f3 : awariika");
renderText(0.72, 0.60, 0.02, "f5 : bardahok");



		end;
	end;
	
    if not self.isMotorStarted and not self.automaticStart then	
        g_currentMission:addHelpButtonText(g_i18n:getText("Start motor"), InputBinding.ZUENDUNG);
	end;
	if self.isMotorStarted then	
        if self.motor.speedLevel ~= 0 then
            g_currentMission:addExtraPrintText("Taste NUM +/-:   "..string.format("%d RPM",self.motor.maxRpm[self.motor.speedLevel]).."");
	    else
            g_currentMission:addExtraPrintText("Taste NUM +/-:   "..string.format("%d RPM",self.motor.maxRpm[3]).."");
	    end;
	end;
end;

function superwse:onEnter()
    Utils.setEmittingState(self.exhaustParticleLow, false);
end;

function superwse:onLeave()


self.farLightActive = false;
setVisibility(self.farLight, self.farLightActive);



    self.rundumleuchtenAn = false;
    for i=1, self.rundumleuchtenAnz do
       setVisibility(self.rundumleuchten[i].light, self.rundumleuchtenAn);
    end;
    self.worklightsActive = false;
	
	if self.radioSound ~= nil then
        stopSample(self.radioSound);
    end;
	
	if not self.deactivateOnLeave then
	    self.allowedZuendung = true;
	    self.zuendungKey = true; 
    else
	    self.allowedZuendung = true;
	    self.zuendungKey = true;
	end;
end;

function superwse:delete()
    delete(self.hornSoundId);
	delete(self.radioSound);
   
end;




function superwse:mouseEvent(posX, posY, isDown, isUp, button)
end;

function key_convert(key)
    if key ~= nil then 
	    local keyname = "";
	    if key > 32 and key < 123 then
	    	keyname = string.upper(string.char(key));
	    elseif key > 255 and key < 266 then
	    	keyname = "NUM "..string.char(key-208);
	    else 
	    	keyname = "";
	    end;
	    return(keyname);
	  end;
end;
